
playnewfile(false)
j1 = Image.load(skin.."/j1.png")
j2 = Image.load(skin.."/j2.png")

--Instruction
i1 = Image.load("images/instruction1.png")
i2 = Image.load("images/instruction2.png")

jaune = Color.new(247, 255, 40)
orange = Color.new(255, 203, 40)
blanc = Color.new(255, 255, 255)
rouge = Color.new(255, 0, 0)
vert = Color.new(150, 250, 0)

color = Color.new(113, 113, 113)
actif = -1
pi = 4*math.atan(1)
n, p = 1, 2						--variable ncessaire pour l'alternance des points
c = {{x=50, y=50},{x=70, y=50}}	--position des points
decalage = {x = 0, y = 0}		--dcalage de la zone d au scrolling
sens = 1
pad = Controls.read()
i = 0
nbobj = 0
deviance = 0
vit = 0.02
xlimit = 0
ylimit = 0
t = Timer.new()
t:start()
timer = Timer.new()
timer:start()
score = 0
vie = 5

--pack = "levels/"		--pack dfaut


function resetlvl()
	actif = -1
	n, p = 1, 2
	c = {{x=50, y=50},{x=70, y=50}}
	decalage = {x = 0, y = 0}
	sens = 1
	i = 0
	deviance = 0
	vit = 0.02
	xlimit = 0
	ylimit = 0
	timer:reset(0)
	timer:start()
end

function drawCircle(x, y, r, color)
	if color==nil then color = Color.new(0, 0, 0) end
	pi = math.pi
	for i=1,r do
		screen:pixel(x+r*math.cos(pi*i), y+r*math.sin(pi*i), color)
	end
end

function loadlevel(number)
	nbobj = 0
	tableau = {num = number, t = 0, map = {}, map2 = {}, pic = nil}
	dofile(pack.."level"..number..".txt")
	level = io.open(pack.."level"..number..".txt", "r")
	level:read("*l")
	for i=1,20 do
		table.insert(tableau.map, {})
		str = level:read("*l")
		str = string.sub(str, 1, string.len(str)-1)
		for j=1,20 do
			tmp = string.sub(str, j, j)
			table.insert(tableau.map[i], tmp)
		end
	end
	for i=1,20 do
		table.insert(tableau.map2, {})
		str = level:read("*l")
		str = string.sub(str, 1, string.len(str)-1)
		for j=1,20 do
			tmp = string.sub(str, j, j)
			tmp = tonumber(tmp)
			if tmp==1 or tmp==2 then nbobj = nbobj+1 end
			table.insert(tableau.map2[i], tmp)
		end
	end
	return tableau
end

function drawOnscreen(lvl_)
	onscreen = Image.createEmpty(512, 512)
	for i=1,20 do
		for j=1,20 do
			tmp = lvl_.map2[i][j]
			if tmp~=0 and tmp~=nil then
				pic = Image.load(skin.."/o"..tostring(tmp)..".png")
				onscreen:blit((j-1)*25, (i-1)*25, pic)
			end
		end
	end
end

function drawlevel(lvl)
	tmp = io.open(pack.."set"..lvl.num..".png", "r")
	if  tmp then
		tmp = Image.load(pack.."set"..lvl.num..".png")
	else
		tmp = Image.load(pack.."set1.png")
	end
	
	offscreen = Image.createEmpty(512, 512)
	for i=1,20 do
		for j=1,20 do
			limity = 0
			u = (string.byte(lvl.map[i][j])-string.byte("A"))
			limitx = 25*math.mod(u, 2)
			limity = 25*math.floor(u/2)
			offscreen:blit((j-1)*25, (i-1)*25, tmp, limitx, limity, 25, 25)
		end
	end
	drawOnscreen(lvl)
end

function clic()
	if actif==-1 then tmp = 1 else tmp = 2 end
	if level.map2[y][x]==tmp then
		level.map2[y][x] = 0
		if tmp==1 then
			playWAV(skin.."/s1.wav")
		else
			playWAV(skin.."/s2.wav")
		end
		nbobj = nbobj-1
		drawOnscreen(level)
	end	
end

function obstacle()
	if level.map[y][x]=="E" then
		sens = -1*sens
	end
end

function anouncelevel(number)
	str = "Level "..number
	font:setPixelSizes(0, 72)
	screen:clear(Color.new(255, 255, 255))
	screen:fontPrint(font, 120, 172, str, Color.new(150, 250, 0))
	screen.waitVblankStart()
	screen.flip()
	System.sleep(1500)
	font:setPixelSizes(0, 12)
end

set = Image.load("images/timebar.png")
function printbar(x, y, ratio)
	screen:blit(x, y, set, 0, 22, 480*(1-ratio), 22)
	screen:blit(x, y, set, 0, 0, 480, 22)
end

function pause()
	System.sleep(200)
	timer:stop()
	playWAV("sons/bip1.wav", true)
	font:setPixelSizes(0, 72)
	screen:fontPrint(font, 140, 174, "PAUSE", orange)
	screen:fontPrint(font, 142, 172, "PAUSE", jaune)
	font:setPixelSizes(0, 24)
	screen:fontPrint(font, 142, 199, "SCORE / HS : "..score.." / "..high, blanc)
	screen:fontPrint(font, 142, 225, "LEVEL : "..niveau, blanc)
	screen:fontPrint(font, 142, 251, lan.Game1.." : "..vie, blanc)
	screen:fontPrint(font, 143, 200, "SCORE / HS : "..score.." / "..high, orange)
	screen:fontPrint(font, 143, 226, "LEVEL : "..niveau, orange)
	screen:fontPrint(font, 143, 252, lan.Game1.." : "..vie, orange)
	screen.waitVblankStart()
	screen.flip()
	repeat
		System.sleep(100)
	until Controls.read():start()
	System.sleep(200)
	timer:start()
end


--Intro d'instruction
screen:blit(0, 0, i1)
screen.waitVblankStart()
screen.flip()
pad = Controls.read()
tmp = 0
while not((pad:cross() or pad:triangle())) and tmp<30 do
	pad = Controls.read()
	System.sleep(100)
	tmp = tmp+1
end
if not(pad:cross() or pad:triangle()) then
	screen:blit(0, 0, i2)
	screen.waitVblankStart()
	screen.flip()
	tmp = 0
	while not((pad:cross() or pad:triangle())) and tmp<30 do
		pad = Controls.read()
		System.sleep(100)
		tmp = tmp+1
	end
end

level = loadlevel(niveau)
drawlevel(level)
if level.pic~=nil then offscreen = level.pic end
anouncelevel(niveau)

while not(pad:triangle()) do
	checkmusic()
	pad = Controls.read()
	if pad:select() then screen:save("shot2.png") end
	i = i+vit*sens
	angle = pi*i
	c[n].x = c[p].x+50*math.cos(angle)
	c[n].y = c[p].y+50*math.sin(angle)
	if c[n].x+20>480 then sens, c[p].x = -1*sens, c[p].x-5 end
	if c[n].x<0 then sens, c[p].x = -1*sens, c[p].x+5 end
	if c[n].y+20>272 then sens, c[p].y = -1*sens, c[p].y-5 end
	if c[n].y<22 then sens, c[p].y = -1*sens, c[p].y+5 end
	if c[n].x>450 and xlimit+480+25+1<512 then xlimit, c[p].x, decalage.x = xlimit+25, c[p].x-25, decalage.x+1 end
	if c[n].y>242 and ylimit+272+25+1<512 then ylimit, c[p].y, decalage.y = ylimit+25, c[p].y-25, decalage.y+1 end
	if c[n].x<30 and xlimit~=0 then xlimit, c[p].x, decalage.x = xlimit-25, c[p].x+25, decalage.x-1 end
	if c[n].y<30 and ylimit~=0 then ylimit, c[p].y, decalage.y = ylimit-25, c[p].y+25, decalage.y-1 end
	if ylimit<0 then ylimit = 0 end
	if xlimit<0 then xlimit = 0 end
	if ylimit>512 then ylimit = 512 end
	if xlimit>512 then xlimit = 512 end
	
	--zone du point mobil
	x = decalage.x + math.ceil((c[n].x+12)/25)
	y = decalage.y + math.ceil((c[n].y+12)/25)
	--**********
	obstacle()
	if (pad:cross() or pad:circle()) and t:time()>200 then
		clic()
		n, p, sens, i, actif = p, n, -1*sens, (angle+pi)/pi, -1*actif
		t:reset(0)
		t:start()
	end
	if pad:start() then pause() end
	
	if timer:time()>level.t then
		a = (level.t*5)/100
		score = score - a
		vie = vie - 1
		playWAV("sons/bad.wav", true)
		font:setPixelSizes(0, 72)
		screen:fontPrint(font, 140, 174, "BOO", orange)
		screen:fontPrint(font, 142, 172, "BOO", jaune)
		font:setPixelSizes(0, 36)
		screen:fontPrint(font, 141, 209, "-"..a, blanc)
		screen:fontPrint(font, 142, 210, "-"..a, rouge)
		screen.waitVblankStart()
		screen.flip()
		System.sleep(1500)
		resetlvl()
	end
	
	if vie==0 then
		playWAV("sons/go.wav", true)
		font:setPixelSizes(0, 72)
		screen:fontPrint(font, 140, 174, "GaME", orange)
		screen:fontPrint(font, 142, 248, "oVer", jaune)
		if score>high then high = score end
		if niveau>max then max = niveau end
		tmp = io.open(pack.."HS.HI", "w")
		tmp:write("high,max="..high..","..max)
		tmp:close()
		tmp = nil
		screen.waitVblankStart()
		screen.flip()
		System.sleep(3000)
		break
	end

	if nbobj==0 then
		a = math.ceil((level.t*7)/100 + ((level.t-timer:time())/10))
		score = score + a
		playWAV("sons/good.wav", true)
		font:setPixelSizes(0, 72)
		screen:fontPrint(font, 140, 174, "WIN", jaune)
		screen:fontPrint(font, 142, 172, "WIN", orange)
		font:setPixelSizes(0, 36)
		screen:fontPrint(font, 141, 209, "+"..a, blanc)
		screen:fontPrint(font, 142, 210, "+"..a, vert)
		screen.waitVblankStart()
		screen.flip()
		System.sleep(1500)
		resetlvl()
		if io.open(pack.."level"..(niveau+1)..".txt", "r") then niveau = niveau+1 end
		level = loadlevel(niveau)
		drawlevel(level)
		if level.pic~=nil then offscreen = level.pic end
		anouncelevel(niveau)
	end
	
	screen:clear()
	screen:blit(0, 0, offscreen, xlimit, ylimit, 480, 272)
	screen:blit(0, 0, onscreen, xlimit, ylimit, 480, 272)
	printbar(0, 0, timer:time()/level.t)
	screen:print(6, 6, score)
	
	screen:drawLine(c[1].x+10, c[1].y+9, c[2].x+9, c[2].y+10, color)
	screen:drawLine(c[1].x+9, c[1].y+10, c[2].x+10, c[2].y+9, color)
	screen:blit(c[1].x, c[1].y, j1)
	screen:blit(c[2].x, c[2].y, j2)

	screen.flip()
	screen.waitVblankStart()
end
Music.stop()

if score>high then high = score end
if niveau>max then max = niveau end
tmp = io.open(pack.."HS.HI", "w+")
tmp:write("high,max="..high..","..max)
tmp:close()
tmp = nil
